### Class

# Rest Proxy

#### Description [src]

    class Rest.Proxy : GObject.Object
    {
      /* No available fields */
    }

`RestProxy` has no publicly available members.

#### Hierarchy

#### Ancestors

- GObject

#### Descendants

- RestOAuth2Proxy

#### Constructors

###### rest_proxy_new

Create a new `RestProxy` for the specified endpoint `url_format`, using the “GET” method.

###### rest_proxy_new_with_authentication

Create a new `RestProxy` for the specified endpoint `url_format`, using the “GET” method.

#### Instance methods

###### rest_proxy_add_soup_feature

This method can be used to add specific features to the `SoupSession` objects that are used by librest for its HTTP connections. For example, if one needs extensive control over the cookies which are used for the REST HTTP communication, it’s possible to get full access to libsoup cookie API by using.

since: 0.7.92

###### rest_proxy_bind

No description available.

###### rest_proxy_bind_valist

No description available.

###### rest_proxy_get_user_agent

No description available.

###### rest_proxy_new_call

Create a new `RestProxyCall` for making a call to the web service. This call is one-shot and should not be re-used for making multiple calls.

###### rest_proxy_set_user_agent

No description available.

###### rest_proxy_simple_run

No description available.

###### rest_proxy_simple_run_valist

No description available.

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

#### Properties

###### Rest.Proxy:binding-required

No description available.

###### Rest.Proxy:disable-cookies

No description available.

###### Rest.Proxy:password

No description available.

###### Rest.Proxy:ssl-ca-file

No description available.

###### Rest.Proxy:ssl-strict

No description available.

###### Rest.Proxy:url-format

No description available.

###### Rest.Proxy:user-agent

No description available.

###### Rest.Proxy:username

No description available.

#### Signals

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct RestProxyClass {
      gboolean (* bind_valist) (
        RestProxy* proxy,
        va_list params
      );
      RestProxyCall* (* new_call) (
        RestProxy* proxy
      );
      gboolean (* simple_run_valist) (
        RestProxy* proxy,
        gchar** payload,
        goffset* len,
        GError** error,
        va_list params
      );
      gboolean (* authenticate) (
        RestProxy* proxy,
        RestProxyAuth* auth,
        gboolean retrying
      );

    }

Class structure for `RestProxy` for subclasses to implement specialised behaviour.

Typically subclasses will override `new_call` to construct a subclass of `RestProxyCall`.

###### Class members

`bind_valist: gboolean (* bind_valist) ( RestProxy* proxy, va_list params )`

  Virtual function called to bind parameters.

`new_call: RestProxyCall* (* new_call) ( RestProxy* proxy )`

  Virtual function called to construct a new `RestProxyCall`.

`simple_run_valist: gboolean (* simple_run_valist) ( RestProxy* proxy, gchar** payload, goffset* len, GError** error, va_list params )`

  Virtual function called when making a “simple” call.

`authenticate: gboolean (* authenticate) ( RestProxy* proxy, RestProxyAuth* auth, gboolean retrying )`

  Class handler for the `RestProxy::authenticate` signal.

#### Virtual methods

###### Rest.ProxyClass.authenticate

Class handler for the `RestProxy::authenticate` signal.

###### Rest.ProxyClass.bind_valist

Virtual function called to bind parameters.

###### Rest.ProxyClass.new_call

Create a new `RestProxyCall` for making a call to the web service. This call is one-shot and should not be re-used for making multiple calls.

###### Rest.ProxyClass.simple_run_valist

Virtual function called when making a “simple” call.